=== tko/Makefile ===
# You need to install the protocol
# buffer compiler and the protocol
# buffer python libraries. The script
# installation_support/autotest-install-packages-deps
# helps to install this and other
# packages on your box for both
# Fedora and Ubuntu.
#
all:
	protoc tko.proto --python_out=.
