=== debian/watch ===
version=3

https://github.com/autotest/autotest/tags .*/(\d[\d\.]+)\.tar\.gz
